<script src="https://unpkg.com/vue/dist/vue.js"></script>
<script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>

<div id="app">
  <h1>Hello App!</h1>
  <p>
    <router-link to="/">Go to Home</router-link>
    <router-link to="/about">Go to About</router-link>
    <router-link to="/categories">Go to Categories</router-link>
  </p>

  <router-view></router-view>
</div>

<script type="module">
    import { CategoriesComponent } from './CategoriesComponent.js'
    import { CategoryComponent } from './CategoryComponent.js'
    const Home = { template: '<div>Home</div>' }
    const About = { template: '<div>About</div>' }

    const routes = [
        { path: '/', component: Home},
        { path: '/about', component: About, meta: { login:true } },
        { path: '/categories', component: CategoriesComponent, meta: { admin:true } },
        { path: '/category/:id', component: CategoryComponent },
        { path: '*', redirect: '/' },
    ]

    const router = new VueRouter({
        routes // short for `routes: routes`
    })

    router.beforeEach((to, from, next) => {
        if (to.matched.some(record => record.meta.login)) {
            let auth = true;
            if (!auth) {
                alert('Halaman untuk yang login')
                next(false)
            }
            else {
                next()
                alert('Berhasil Masuk')
            }
        }
        else if (to.matched.some(record => record.meta.admin)) {
            let admin = false;
            if (!admin) {
                alert('Halaman untuk Seorang Admin')
                next(false)
            }
            else {
                next()
                alert('Berhasil Masuk')
            }
        }
        else{
            next()
        }
    })

    const app = new Vue({
        router
    }).$mount('#app')
</script>